/*! Types of requests we might encounter. */
pub enum RequestType {
    BlockageMigration,
    CheckBlockage,
    IssueInvite,
    LevelUp,
    Migration,
    OpenInvite,
    RedeemInvite,
    TrustPromotion,
}

impl TryFrom<u8> for RequestType {
    type Error = &'static str;

    fn try_from(value: u8) -> Result<Self, Self::Error> {
        match value {
            1 => Ok(RequestType::BlockageMigration),
            2 => Ok(RequestType::CheckBlockage),
            3 => Ok(RequestType::IssueInvite),
            4 => Ok(RequestType::LevelUp),
            5 => Ok(RequestType::Migration),
            6 => Ok(RequestType::OpenInvite),
            7 => Ok(RequestType::RedeemInvite),
            8 => Ok(RequestType::TrustPromotion),
            _ => Err("Byte given does not represent a valid request type."),
        }
    }
}
